Unit QSG4R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSG4R(var INT :Real; A :Real; B :Real; F :Func_F1);

implementation

procedure QSG4R(var INT :Real; A :Real; B :Real; F :Func_F1);
var
K :Integer;
D,E,G,H :Real;
C :Array [0..4] of Real;
C1 :Array [0..4] of Real;
label
_1;
begin
{   DATA  FORTRAN  }
C[0] := 0.4869532;
C[1] := 0.4325316;
C[2] := 0.3397047;
C[3] := 0.2166976;
C[4] := 0.07443717;
C1[0] := 0.0333356;
C1[1] := 0.0747256;
C1[2] := 0.1095431;
C1[3] := 0.1346333;
C1[4] := 0.1477621;
H := 0.0;
D := 0.5*(A+B);
E := B-A;
for K:=1 to 5 do
 begin
  G := E*C[K-1];
  H := H+C1[K-1]*(F(D+G)+F(D-G));
_1:
 end;
INT := H*E;
end;

end.
